;;;           AutoCad2000/2002.
;;; 
;;; 
;;;   .. . 2003. 
;;; 
;;;         ,     . 
;;;
;;;          
;;;    (load "plota3")
;;; c   ,   plota3.lsp     , 
;;;  Tools -> Load Application -> Load	
;;;
;;;        plota3.
;;;     "Page setup"    
;;; ,    ,  ,    (Windows<),
;;; ,   ,  ,    .
;;; : 
;;;	-      ,   Windows<. 
;;;	-   FIT     ,    
;;;	    .
;;;	-    ,    .  
;;;	    ,   .	
;;;
;;;   ,     PLOTA3,    
;;;  ,       ,     
;;; "(P)/ (M)/ (N):<N>". 
;;;       , ..   . 
;;;         "M".
;;;         ,   ,
;;;  "N"   .      "Page setup"   
;;;   .
;;; 
;;; 
;;;        ( "P"),    
;;;     (  1 .).  
;;;    .  
;;;
;;;
;;;    AutoCad2002  :
;;;	Xerox Centr Pro 320/315 XL -  -;
;;;	Epson Color 1160 -  ;
;;;	CM 6337 -  , 9  ( FX-100+);
;;;	HP 7475 - 6-  .
;;;
;;;    karnau@farlep.net
;;;

(defun C:plota3	(/	    grpdict    grpd	  PlotType   PlotRotat
		 xdeltmin   ydeltmin   xdeltmax	  ydeltmax   paperWith
		 paperHeigt orignX     orignY	  areaMinX   areaMinY
		 areaMaxX   areaMaxY   flagPlot	  areaplotX  areaplotY
		 Scale1	    NY	       offset	  offset1    XX
		 XB	    YY	       YB	  KolX	     KolY
		 moveDist   newPoint   oldPoint   e1	     unitsPaper
		)
  (setq grpdict (dictsearch (namedobjdict) "ACAD_PLOTSETTINGS"))
  (setq
    grpd (dictsearch
	   (cdar (dictsearch (cdar (cdDDDr grpdict)) "ACAD_LAYOUT"))
	   (GETVAR "CTAB")
	 )
  )
  (setq PlotType (cdr (assoc '74 grpd)));Displey-0;extents-1;limits-2;View-3;Windows-4;Layout-5
  (IF (/= PlotType 4)
    (alert
      "         ,
     'Window<' !
      ,
 'Page setup'   Window<,
   ."
    )
    (progn
      (if (= 1 (cdr (assoc '72 grpd)))(setq unitsPaper "M")(setq unitsPaper "I"))
      (setq PlotRotat (cdr (assoc '73 grpd)))
      ;; 0-, 1-, 2-+, 3 +
      (if (or (= PlotRotat 0) (= PlotRotat 2))
	(progn
	  (setq xdeltmin (cdr (assoc '40 grpd)))
	  (setq ydeltmin (cdr (assoc '41 grpd)))
	  (setq xdeltmax (cdr (assoc '42 grpd)))
	  (setq ydeltmax (cdr (assoc '43 grpd)))
	  (setq paperWith (cdr (assoc '44 grpd)))
	  (setq paperHeigt (cdr (assoc '45 grpd)))
	)
	(progn
	  (setq xdeltmin (cdr (assoc '41 grpd)))
	  (setq ydeltmin (cdr (assoc '40 grpd)))
	  (setq xdeltmax (cdr (assoc '43 grpd)))
	  (setq ydeltmax (cdr (assoc '42 grpd)))
	  (setq paperWith (cdr (assoc '45 grpd)))
	  (setq paperHeigt (cdr (assoc '44 grpd)))
	)
      )
      (setq orignX (cdr (assoc '46 grpd)))
      (setq orignY (cdr (assoc '47 grpd)))
      (setq areaMinX (cdr (assoc '48 grpd)))
      (setq areaMinY (cdr (assoc '49 grpd)))
      (setq areaMaxX (cdr (assoc '140 grpd)))
      (setq areaMaxY (cdr (assoc '141 grpd)))
;;;      (setq flagPlot (cdr (assoc '70 grpd)))
      
;;;  
      (setq Scale1 (/ (cdr (assoc '143 grpd)) (cdr (assoc '142 grpd))))

;;;     
;;;   
      (setq areaplotX (* (- paperWith xdeltmin xdeltmax) Scale1))
;;;     
      (setq areaplotY (* (- paperHeigt ydeltmin ydeltmax) Scale1))
;;;         
      (setq areaPlotW (abs (- areaMaxX areaMinX)))
      (setq areaPlotH (abs (- areaMaxY areaMinY)))
      (setq kolX (if (> (rem areaPlotW areaplotX) 0)
		   (+ 1 (fix (/ areaPlotW areaplotX)))
		   (fix (/ areaPlotW areaplotX))
		 )
      )
      (setq kolY (if (> (rem areaPlotH areaplotY) 0)
		   (+ 1 (fix (/ areaPlotH areaplotY)))
		   (fix (/ areaPlotH areaplotY))
		 )
      )
;;;  
      (setq e1 (ssadd))
      (setq YY areaMinY)
      (setq XX areaMinX)
      (repeat (+ kolY 1) ;  
	(progn
	  (entmake
	    (list
	      '(0 . "line")
	      '(100 . "AcDbEntity")
	      (cons 410 (getvar "CTAB"))
	      '(100 . "AcDbline")
	      '(62 . 6)
	      (cons 10 (trans (list XX YY) 2 0))
	      (cons 11 (trans (list (+ XX (* kolX areaplotX)) YY) 2 0))
	    )
	  )
	  (ssadd (entlast) e1)
	  (setq YY (+ YY areaplotY))
	)
      )
      (setq YY areaMinY)
      (repeat (+ kolX 1) ;  
	(progn
	  (entmake
	    (list '(0 . "line")
		  '(100 . "AcDbEntity")
		  (cons 410 (getvar "CTAB"))
		  '(100 . "AcDbline")
		  '(62 . 6)
		  (cons 10 (trans (list XX YY) 2 0))
		  (cons	11
			(trans (list XX (+ YY (* kolY areaplotY))) 2 0)
		  )
	    )
	  )
	  (ssadd (entlast) e1)
	  (setq XX (+ XX areaplotX))
	)
      )
      (setq XX areaMinX)
      (setq oldcmdecho (getvar "CMDECHO"))
      (setvar "CMDECHO" 0)
      (setq moveDist (list 0.0 0.0))
      (setq NY "M")
      (while (= NY "M")
	(PROGN
	  (initget 0 "P N M")
	  (setq
	    NY
	     (getkword "(P)/ (M)/ (N):<N>")
	  )
	  (if (= NY nil)
	    (setq NY "N")
	  )
	  (if (= NY "M")
	    (progn
	      (command "move" e1 "" (setq oldPoint (getpoint)) pause)
	      (setq newPoint (getvar "LASTPOINT"))
	      (setq moveDist (mapcar '+
				     moveDist
				     (mapcar '- newPoint oldPoint)
			     )
	      )
	    )
	  )
	)
      )
      (command "erase" e1 "") ;  
      (if (= NY "P")
	(progn
	  (progn
	    (setq kolKop (getint " . : <1>"))
	    (if	(= kolKop nil)
	      (setq kolKop 1)
	    )
	    (setq oldOsnap (GETVAR "OSMODE"))
	    (SETVAR "OSMODE" 16384)  ;   
	    (command "undo" "m") ;     UNDO
	    (setq areaMinX (+ areaMinX (car (trans moveDist 1 2))))
	    (setq areaMinY (+ areaMinY (cadr (trans moveDist 1 2))))
	    (setq offset (list areaMinX areaMinY))
	    (setq
	      offset1 (mapcar '+ offset (list areaplotX areaplotY))
	    )
	    (repeat kolY
	      (setq offset (list areaMinX (cadr offset)))
	      (repeat kolX
		(progn
		  (if (= (getvar "CTAB") "Model")
;;;		       
		    (command "-plot" "Y" "" "" "" unitsPaper "" "" "" (trans offset 2 1)
			     (trans offset1 2 1) "" "" "" "" "" "" "" "" ""
		    )
;;;		       
		    (command "-plot" "Y" "" "" "" unitsPaper "" "" "" (trans offset 2 1)
			     (trans offset1 2 1) "" "" "" "" "" "" "" "" "" "" ""
		    )
		  )
		  (setq offset (mapcar '+ offset (list areaplotX 0)))
		  (setq
		    offset1 (mapcar '+ offset1 (list areaplotX 0))
		  )
		)
	      )
	      (setq offset (mapcar '+ offset (list 0 areaplotY)))
	      (setq offset1 (mapcar '+ offset1 (list 0 areaplotY)))
	    )
	  )
	  (command "undo" "b")
	  (SETVAR "OSMODE" oldOsnap)
	  (setvar "CMDECHO" oldcmdecho)
	)
      )
    )
  )
)
